function [net, rt] = PMC_training(entree, sortie, n_cache, nb_apprentissage)

[n_entree, nb_echantillons] = size(entree);
[n_sortie, ~] = size(sortie);

% net = newff(entree, sortie, n_cache, {'tansig' 'tansig'}, 'trainscg');
net = feedforwardnet(n_cache, 'trainscg');

net.trainParam.epochs = 1000; % Le nombre de cycle dapprentissage est fix  1000

net.trainParam.lr = 0.02; % Le pas dapprentissage est gal  0.02

net.trainParam.show = 100; % Des informations sur les performances du rseau sont affiches tous les 100 cycles dapprentissage

net.trainParam.goal = 1e-10; % Lalgorithme dapprentissage sarrte lorsque lerreur quadratique moyenne est infrieure  1e-10

net.trainParam.min_grad = 1e-10; % Lalgorithme dapprentissage sarrte lorsque le module du gradient est infrieur  1e-10

net.divideParam.trainRatio = nb_apprentissage / nb_echantillons; 
net.divideParam.valRatio = 0;  %  On n'utilise pas d'ensemble de validation.
net.divideParam.testRatio = (nb_echantillons - nb_apprentissage) / nb_echantillons; 

net = train(net, entree, sortie);

entree_test = entree(:,(nb_apprentissage + 1): nb_echantillons);
sortie_test = sortie(:,(nb_apprentissage + 1): nb_echantillons);
rt = sim(net, entree_test, [], [], sortie_test);
end

